/*************************************************************************/
/* memalloc.c - Kimmo Fredriksson, modified by Teemu Kivioja 26.5.1998   */
/*************************************************************************/


#include			<stdlib.h>
#include			<stdio.h>
#include			"memalloc.h"

void	*salloc( int n, int b )
{
	void	*a = calloc( n, b );

	if( !a )
	{
		fprintf(stderr, "Ethan: memory allocation failure, salloc\n" );
		exit( 1 );
	}

	return a;
}

void	**allocate_2d( int r, int c, int e )
{
	int	i;
	void	**a = ( void ** )salloc( r, sizeof( void * ));

	a[ 0 ] = ( void * )salloc( r * c,  e ); /* sizeof void is not ansi...*/
	for( i = 1; i < r; i++ ) a[ i ] = ( char * )( a[ 0 ] ) + i * c * e;

	return a;
}


void	**reallocate_2d_rows( void ** a, int r, int c, int e )
{
	int	i;

	a[ 0 ] = ( void * )realloc( a[ 0 ], r * c * e );
	a = ( void ** )realloc( a, r * sizeof( void * ));
	for( i = 1; i < r; i++ ) a[ i ] = ( char * )( a[ 0 ] ) + i * c * e;

	return a;
}


void	*allocate_1d( int n, int e )
{
	void	*a = salloc( n, e );

	return a;
}

void	free_1d( void *a )
{
	free( a );
}

void	free_2d( void **a )
{
	free( a[ 0 ] );
	free( a );
}









